#include "setprecision.h"
#include "matrices.h"

MatrixPtr two( MatrixPtr& y ){
  symtable variables;
  variables[ "y" ] = y;

  variables["y"] = MatrixPtr( *newValue( "2" ) * *getVariable( variables, "y" ) );

return variables[ "y" ];}

int main(){
  try{
    symtable variables;
    setPrecision();
    variables["b"] = newValue( "1" );
    cout << "b = " << endl << *getVariable( variables, "b" ) << endl;
    variables["a"] = two( getVariable( variables, "b" ) );
    cout << "a = " << endl << *getVariable( variables, "a" ) << endl;
    cout << "b = " << endl << *getVariable( variables, "b" ) << endl;
  }
  catch( InvalidOperation n ){ 
    cerr << n.lError << endl; 
  }
  catch( ... ){ 
    cerr << "Unknown exception was caught." << endl; 
  }
}


