#!../parser

function x=mymax( a,b )
	if( a> b) x=a;
	else      x=b;
	end
end

[1, 4-2, 4 mymax(2,5)]
[1, 4-2, 4, mymax( 2, 5 )]
[1  4-2  4  mymax( 2, 5 )]
[1  4 -2  mymax( 2, 5 )]
[1  4 -2  mymax(2 -5,5)]

[2,  4 -2  mymax(2 -5,5)]
[2  4, -2  mymax(2 -5,5)]
[2  4 -2,  mymax(2 -5,5)]
[2  4 -2  mymax(2 -5,5)]

[4 -2 ;  mymax(2 -5,5)  6]
[4, -2 ; mymax(2 -5,5)  6]
[4 -2, ; mymax(2 -5,5)  6]
[4 -2  ; mymax(2 -5,5), 6]

[ 4 -2  
 mymax(2 -5,5)  6]
[4, -2  
 mymax(2 -5,5)  6]
[ 4 -2,  
mymax(2 -5,5)  6]
[4 -2
 mymax(2 -5,5), 6]

[ 4-2 1  
 mymax(2 -5,5)  6]
[4-2,1  
 mymax(2 -5,5)  6]
[ 4-2 1  
mymax(2 -5,5)  6]
[4-2 1
 mymax(2 -5,5), 6]


mode(interval);
I[ 2,3[
I[ 2,3]
I] 2,3[
I] 2,3]


I[ 2,mymax([3],5)]
I[ 2,mymax([3],5)[
I] 2,mymax([3],5)]
I] 2,mymax([3],5)[



%I[ 2,[3 5][ 
%something we do not allow anymore, this is ambiguous in lexer. We cannot know 
%here if it was end if interval or start of matrix expression at lexing level.
%This could be resolved if we only allowed input of balanced interval brackets for intervals.
%You can always circumvent it by putting it into a variable since we do allow matrices in intervals 
%in this case we take the first element if its dimension is greater than 1,1

x=[3 5];
I[2,x[ %will give I[2,3]

%since regular matrices now work exactly the same as in matlab and it only causes the
%above interval construction 'I[ 2,[3 5][' to fail. It is a good trade-off since we introduced the interval construction as a new language element anyway.

