#include "setprecision.h"
#include "matrixapi.h"

int main(){
  try{
    symtable variables;
    setPrecision();
    variables["ans"] = setMode( "double" );
    variables["k"] = newValue( "0" );

    while( ( *getVariable( variables, "k" ) < *MatrixPtr( *newValue( "3" ) * *newValue( "2" ) ) ) ){
      variables["k"] = MatrixPtr( *getVariable( variables, "k" ) + *newValue( "1" ) );
      cout << "k = " << endl << *getVariable( variables, "k" ) << endl;
    }
    cout << *newStrValue( "\n\nexecuting a long while... " ); 
    cout << flush;
    variables["k"] = newValue( "0" );

    while( ( *MatrixPtr( *getVariable( variables, "k" ) + *newValue( "1" ) ) < *MatrixPtr( *newValue( "5" ) * *newValue( "2000" ) ) ) ){
      variables["k"] = MatrixPtr( *getVariable( variables, "k" ) + *newValue( "1" ) );
    }
    cout << *newStrValue( "done. \ni= " ); 
    cout << *getVariable( variables, "k" ); 
    cout << *newStrValue( "\n" ); 
    cout << flush;
  }
  catch( InvalidOperation n ){ 
    cerr << n.lError << endl; 
  }
  catch( ... ){ 
    cerr << "Unknown exception was caught." << endl; 
  }
}


