#include "setprecision.h"
#include "matrixapi.h"

int main(){
  try{
    symtable variables;
    setPrecision();
    variables["n"] = MatrixPtr( - *newValue( "5" ) );
    cout << "n = " << endl << *getVariable( variables, "n" ) << endl;
    variables["z"] = MatrixPtr( - *newValue( ".9E4" ) );
    cout << "z = " << endl << *getVariable( variables, "z" ) << endl;
    variables["ans"] = deepCopy( MatrixPtr( getVariable( variables, "abs" )->getElement( *getVariable( variables, "z" ) ) ) );
    cout << "ans = " << endl << *getVariable( variables, "ans" ) << endl;
    variables["ans"] = deepCopy( MatrixPtr( getVariable( variables, "square" )->getElement( *MatrixPtr( getVariable( variables, "abs" )->getElement( *getVariable( variables, "n" ) ) ) ) ) );
    cout << "ans = " << endl << *getVariable( variables, "ans" ) << endl;
    cout << *MatrixPtr( getVariable( variables, "square" )->getElement( *MatrixPtr( getVariable( variables, "square" )->getElement( *getVariable( variables, "n" ) ) ) ) ) << endl;
  }
  catch( InvalidOperation n ){ 
    cerr << n.lError << endl; 
  }
  catch( ... ){ 
    cerr << "Unknown exception was caught." << endl; 
  }
}


