#include "setprecision.h"
#include "matrixapi.h"

MatrixPtr square( MatrixPtr n ){
  symtable variables;
  variables[ "n" ] = n;

  variables["n"] = MatrixPtr( *getVariable( variables, "n" ) * *getVariable( variables, "n" ) );
  return variables[ "n" ];
return variables[ "n" ];}

int main(){
  try{
    symtable variables;
    setPrecision();
    variables["ans"] = setMode( "mpieee" );
    variables["ans"] = setRounding( "nearest" );
    variables["ans"] = setRadix( newValue( "2" ) );
    variables["ans"] = setPrecision( newValue( "53" ) );
    variables["ans"] = setExponent( MatrixPtr( - *newValue( "127" ) ), newValue( "128" ) );
    variables["A"] = newValue( "3" );
    cout << "A = " << endl << *getVariable( variables, "A" ) << endl;
    variables["A"] = MatrixPtr( *newValue( "3" ) + *newValue( "2" ) );
    cout << "A = " << endl << *getVariable( variables, "A" ) << endl;
    variables["B"] = deepCopy( getVariable( variables, "A" ) );
    cout << "B = " << endl << *getVariable( variables, "B" ) << endl;
    variables["A"] = MatrixPtr( *getVariable( variables, "A" ) + *newValue( "1" ) );
    cout << "A = " << endl << *getVariable( variables, "A" ) << endl;
    cout << "A = " << endl << *getVariable( variables, "A" ) << endl;
    cout << "B = " << endl << *getVariable( variables, "B" ) << endl;
    variables["x"] = MatrixPtr( *MatrixPtr( *newValue( "1" ) + *MatrixPtr( *newValue( "2" ) * *newValue( "3" ) ) ) - *newValue( "7" ) );
    cout << "x = " << endl << *getVariable( variables, "x" ) << endl;
    variables["x"] = MatrixPtr( *MatrixPtr( *MatrixPtr( *newValue( "1" ) + *newValue( "2" ) ) * *newValue( "3" ) ) - *newValue( "7" ) );
    cout << "x = " << endl << *getVariable( variables, "x" ) << endl;
    variables["x"] = MatrixPtr( *newValue( "1" ) + *MatrixPtr( *newValue( "2" ) * *MatrixPtr( *newValue( "3" ) - *newValue( "7" ) ) ) );
    cout << "x = " << endl << *getVariable( variables, "x" ) << endl;

    while( ( *getVariable( variables, "x" ) < *MatrixPtr( *getVariable( variables, "A" ) - *newValue( "5" ) ) ) ){
      variables["x"] = MatrixPtr( *getVariable( variables, "x" ) + *newValue( "1" ) );
      cout << "x = " << endl << *getVariable( variables, "x" ) << endl;

      if( *getVariable( variables, "x" ) == *newValue( "1" ) ){
        cout << *newStrValue( "the end" ) << endl;
      }
      else{
        cout << *newStrValue( "still to go..." ) << endl;
      }
    }
    variables["sinone"] = MatrixPtr( newValue( "1" )->sin() );
    cout << "sinone = " << endl << *getVariable( variables, "sinone" ) << endl;
    variables["cosone"] = MatrixPtr( newValue( "1" )->cos() );
    cout << "cosone = " << endl << *getVariable( variables, "cosone" ) << endl;
    variables["twopowthree"] = MatrixPtr( newValue( "2" )->pow( *newValue( "3" ) ) );
    cout << "twopowthree = " << endl << *getVariable( variables, "twopowthree" ) << endl;
    variables["ans"] = MatrixPtr( - *inputValue( newStrValue( "give value that will be negated and put into ans " ) ) );
    cout << "ans = " << endl << *getVariable( variables, "ans" ) << endl;
    variables["A"]->setElement( *newValue( "1" ), *newValue( "1" ), *newValue( "2" ) );
    cout << "A = " << endl << *getVariable( variables, "A" ) << endl;
    variables["ans"] = square( square( MatrixPtr( getVariable( variables, "A" )->getElement( *newValue( "1" ), *newValue( "1" ) ) ) ) );
    cout << "ans = " << endl << *getVariable( variables, "ans" ) << endl;
  }
  catch( InvalidOperation n ){ 
    cerr << n.lError << endl; 
  }
  catch( ... ){ 
    cerr << "Unknown exception was caught." << endl; 
  }
}


