#include "setprecision.h"
#include "matrixapi.h"

int main(){
  try{
    symtable variables;
    setPrecision();
    cout << *newStrValue( "without ellips" ); 
    cout << *newStrValue( "\n" ); 
    cout << flush;
    variables["A"] = MatrixPtr( *newValue( "1" ) + *newValue( "2" ) );
    cout << "A = " << endl << *getVariable( variables, "A" ) << endl;
    variables["ans"] = MatrixPtr( *newValue( "3" ) * *newValue( "2" ) );
    cout << "ans = " << endl << *getVariable( variables, "ans" ) << endl;
    cout << *newStrValue( "now with ellips" ); 
    cout << *newStrValue( "\n" ); 
    cout << flush;
    variables["A"] = MatrixPtr( *MatrixPtr( *newValue( "1" ) + *newValue( "2" ) ) + *MatrixPtr( *newValue( "3" ) * *newValue( "2" ) ) );
    cout << "A = " << endl << *getVariable( variables, "A" ) << endl;
    cout << *newStrValue( "with a couple of ellipses" ); 
    cout << *newStrValue( "\n" ); 
    cout << flush;
    variables["A"] = MatrixPtr( *MatrixPtr( *newValue( "1" ) + *newValue( "2" ) ) + *MatrixPtr( *newValue( "3" ) * *newValue( "2" ) ) );
    cout << "A = " << endl << *getVariable( variables, "A" ) << endl;
    cout << *newStrValue( "testing expressions without assigns" ); 
    cout << *newStrValue( "\n" ); 
    cout << flush;
    variables["A"] = newValue( "3" );
    cout << "A = " << endl << *getVariable( variables, "A" ) << endl;
    variables["ans"] = MatrixPtr( *getVariable( variables, "A" ) + *newValue( "1" ) );
    cout << "ans = " << endl << *getVariable( variables, "ans" ) << endl;
  }
  catch( InvalidOperation n ){ 
    cerr << n.lError << endl; 
  }
  catch( ... ){ 
    cerr << "Unknown exception was caught." << endl; 
  }
}


