#!../parser


%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
% function without parameters
function v=hello()
  v=0;
  a=1
  %just to test a little depth...
  if a<=1
    if a>=1
      if a==1
        if a~=0
          println 'inside nested if!'
        end
      end
    end
  end
  println('hello there!')
  return
end

%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
% function defined without parameters
% and without () and also assumes implicit
% return
function v=hellotwo
  v=0;
  disp('hello\tagain!')
end


%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
% function with parameters
function d=test(a,b,c)
  d=a+b+c;
  print 'a+b+c= ', d
  print '\n'
  return
end


%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
% function that uses return
% and overrides the defined square function
% in the functions dir
function k=negsquare(k)
  k=-k*k;
  return
end


%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
% fac1 which uses implicit return
function n=fac1(n)
  if(n<=1)
    n=1;
  else
    n=n*fac1(n-1);
  end
end


%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
% fac2 with explicit and implicit return
function k=fac2(k)
  if(k<=1)
    k=1;
    return
  end
  k=k*fac2(k-1);
end






%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
% main

glob=5;

hello();
hello;       %call to function without the ()
hellotwo;    %call to hellotwo defined without () and used without ()

test(1,2,3);

print '\nfac1 test:' print '\n'
for l=1:8
  print 'fac1(',l,')=',fac1(l) print '\n'
end


disp('\nfac2 test:')
for l=1:5
  print 'fac2(',l,')=',fac2(l) print '\n'
end

disp('\nusing factorial from functions dir to compute fac(8)');
factorial(8)

disp('glob='), disp(glob)
disp('negsquare(glob)='),disp( negsquare(glob) )


